package es.uv.garcosda.api.controllers;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestTemplate;

import es.uv.garcosda.shared.Video;

@RestController
@RequestMapping("/api/v1/videos")
@CrossOrigin
public class VideosController {
	
	private RestTemplate template;
	@Value("${api.uri.videos}")
	private String videosApi;
	
	public VideosController() {
		this.template = new RestTemplate();
	}
	
	@GetMapping()
	public ResponseEntity<?> findVideos() {
		ResponseEntity<Video[]> response = template.getForEntity(videosApi, Video[].class); 
		if(response.getStatusCode() == HttpStatus.OK) {
			List<Video> videos = Arrays.stream(response.getBody()).collect(Collectors.toList());
			return new ResponseEntity<List<Video>>(videos, HttpStatus.OK);
		}
		return new ResponseEntity<String>("API returns no response", HttpStatus.BAD_REQUEST);		
	}

	
}
